"use strict"
if (window.jQuery == undefined) {
    console.error("Noti requries jQuery");
}
else {
    var noti = (function($) {
        
        //User config options
        var configOptions = {};


        function init(mOptions) {
            configOptions = mOptions;
            return this
        }
    
    
        //Creating contianer element using custom function
        var container = createElement("DIV", document.body, {
            idName: getOptions().containerId
        })

        //Creating notification element
        function createNoti(options) {
            var notiEl = createElement("DIV", container, {
                className: getOptions().notiElClass,
                innerHTML: options.message,
                type:options.type
            })
            
            handelAnimation(notiEl,options)

            handelEvents(notiEl,options)
            
            return this
        }
        
        //Creates element and add classes and text then appends the new element to specified parent element then return new element
        function createElement(el, elParent, options) {
            console.log(getOptions())
            var element = document.createElement(el);

            if (options.type){
                element.className = options.className;
                
                var message = document.createElement("DIV");
                message.className = getOptions().messageClass;
                message.innerHTML = options.innerHTML;
                element.appendChild(message);
                
                for(var i=0;i<getOptions().itemClasses.length;i++){
                    
                    if(options.type == getOptions().itemClasses[i].type){
                        console.log(getOptions().itemClasses[i].className)
                        element.className = element.className + " " +  getOptions().itemClasses[i].className;                       
                    }
                }
            }             
            
            if (elParent && options.type)
                elParent.appendChild(element)                
            else if(elParent)
                elParent.insertBefore(element,elParent.firstChild);
            if (options.idName)
                element.id = options.idName
                

            return element;
        }
            
        
        //Hide element then fade it in then callback
        function handelAnimation(el,options){
            $(el).hide();
            $(el).fadeIn();  
            if(options.onShow)
                options.onShow()
        }
        
        //Handling tap to dismiss and sticky
        function handelEvents(el,options){
            if(getOptions().tapToDismiss == true){
                $(el).click(function() {
                    $(this).fadeOut(function() {
                        $(this).remove();
                        if (options.onClick)
                            options.onClick();
                    });
                });     
            }
            if(options.sticky != true)
                timerRemove(el, options.showDuration);                
        }
        
        //Removes item after specified time if the mouse is not hoverd over the element
        function timerRemove(el, elapse, mouseState) {
            var elHover = mouseState;
            $(el).hover(function() {
                elHover = true;
            }, function() {
                elHover = false;
            });
            setTimeout(function() {
                if (!elHover) {
                    $(el).fadeOut(function() {
                        $(el).remove();
                    });
                }
                else {
                    timerRemove(el, 1, elHover);
                }
            }, elapse*1000);
        }

        //Return default values
        function getDefaultValues() {
            return {
                containerId: "noti",
                notiElClass: "notification",
                tapToDismiss: true,
                messageClass: "notification-message",
                itemClasses: [
                    {
                        type:"success",
                        className:"success"
                    },
                    {
                        type:"error",
                        className:"error"
                    },
                    {
                        type:"warning",
                        className:"warning"
                    },                    
                ]
            }
        }

        function getOptions() {
            return $.extend({}, getDefaultValues(), configOptions)
        }

        //Public api
        return {
            createNoti: createNoti,
            init: init
        }

    })($)

}